#ifndef INC_DEFINES_H_
#define INC_DEFINES_H_

//---------------------------------------------------------------------------
// Includes

//---------------------------------------------------------------------------
// Globale Makros
#ifndef TRUE
//! \def TRUE
//! \brief Boolsches 'true'
#define TRUE	__TRUE
#endif

#ifndef FALSE
//! \def FALSE
//! \brief Boolsches 'false'
#define FALSE	__FALSE
#endif

#ifndef LO_NIBBLE
//! \def LO_NIBBLE
//! \brief Oberes Nibble eines Bytes
#define LO_NIBBLE(c)				((unsigned char)(c) & 0x0f)
#endif
#ifndef HI_NIBBLE
//! \def HI_NIBBLE
//! \brief Unteres Nibble eines Bytes
#define HI_NIBBLE(c)				((unsigned char)(c) >> 4)
#endif

#ifndef LOBYTE
//! \def LOBYTE
//! \brief Oberes Bytes eines Halbwortes
#define LOBYTE(w)	((unsigned char)((unsigned short)(w) & 0xff))
#endif
#ifndef HIBYTE
//! \def HIBYTE
//! \brief Unteres Bytes eines Halbwortes
#define HIBYTE(w)	((unsigned char)((unsigned short)(w) >> 8))
#endif

#ifndef LOWORD
//! \def LOWORD
//! \brief Oberes Halbwortes eines Wortes
#define LOWORD(l)	((unsigned short)((unsigned long)(l) & 0xffff))
#endif
#ifndef HIWORD
//! \def HIWORD
//! \brief Unteres Halbwortes eines Wortes
#define HIWORD(l)	((unsigned short)((unsigned long)(l) >> 16))
#endif

#ifndef MAX
//! \def MAX
//! \brief Auswahl des gr��eren aus zwei Werten
#define MAX(x, y)	(((x) < (y)) ? (y) : (x))
#endif

#ifndef MIN
//! \def MIN
//! \brief Auswahl des kleineren aus zwei Werten
#define MIN(x, y)	(((x) < (y)) ? (x) : (y))
#endif

#ifndef BIT
//! \def BIT
//! \brief Auswahl einer Bitstelle
#define BIT(n)		(((unsigned long)(1)) << (n))
#endif

#ifndef CHECKBIT
//! \def CHECKBIT
//! \brief Pr�fung, ob die gegebenen Bits gesetzt sind
#define CHECKBIT(x,y)		((x) & (y))
#endif
#ifndef SETBIT
//! \def SETBIT
//! \brief Die gegebenen Bits setzen
#define SETBIT(x,y)			((x) |= (y))
#endif
#ifndef CLEARBIT
//! \def CLEARBIT
//! \brief Die gegebenen Bits l�schen
#define CLEARBIT(x,y)		((x) &=  ~(y))
#endif
#ifndef TOGGLEBIT
//! \def TOGGLEBIT
//! \brief Die gegebenen Bits im Wert wechseln
#define TOGGLEBIT(x,y)		((x) ^= (y))
#endif

#ifndef MODIFYREG
//! \def MODIFYREG
//! \brief Den angegebenen Bereich im Register neu setzen
#define MODIFYREG(REG, CLEARMASK, SETMASK)  ((REG) = (((REG) & (~(CLEARMASK))) | (SETMASK)))
#endif

#ifndef ABS
//! \def ABS
//! \brief Absolutwert einer Zahl
#define ABS( a ) (((a) < 0 )? (-(a)) : (a))
#endif

#ifndef elemof
//! \def elemof
//! \brief Anzahl von Werten in einem Array
#define elemof(x) (sizeof(x)/sizeof(*(x)))
#endif

#if  defined ( __GNUC__ )
  #ifndef __weak
//! \def __NOINLINE
//! \brief Compileranweisung: Funktion kann �berschrieben werden
    #define __weak   __attribute__((weak))
  #endif /* __weak */
  #ifndef __packed
//! \def __NOINLINE
//! \brief Compileranweisung: Datenstrukturen sollen nicht aufgef�llt werden (Alignment)
    #define __packed __attribute__((__packed__))
  #endif /* __packed */
  #ifndef __NOINLINE
//! \def __NOINLINE
//! \brief Compileranweisung: Funktion soll nicht inlined werden
  #define __NOINLINE __attribute__ ( (noinline) )
  #endif
#endif /* __GNUC__ */

//---------------------------------------------------------------------------
// Globale Typen

//---------------------------------------------------------------------------
// Globale Variablen

//---------------------------------------------------------------------------
// Globale Funktionen

#endif /* INC_DEFINES_H_ */
