//---------------------------------------------------------------------------
// Includes
#include "main.h"
#include <stdio.h>		// EOF
#include <unistd.h>		// getopt

#include "usbgadget.h"
#include "functionfs.h"

//---------------------------------------------------------------------------
// Private Makros

//---------------------------------------------------------------------------
// Private Typen

//---------------------------------------------------------------------------
// Private Funktionen

//---------------------------------------------------------------------------
// Private Variablen

//---------------------------------------------------------------------------
// Globale Variablen
bool bverbose = false;

//---------------------------------------------------------------------------

int main (int argc, char *argv[])
{
	int ret = 0;

	// Optionen prüfen
	int c;
	while ((c = getopt(argc, argv, "v")) != EOF)
	{
		switch (c)
		{
			case 'v':
			{
				bverbose = true;
				continue;
			}
		}
	}

	// Gadget initialisieren
	ret = USBgadget_Init();
	if (ret < 0)
		return ret;

	// FunctionFS einrichten
	ret = FunctionFS_Init();
	if (ret < 0)
		return ret;

	// Gadget starten
	USBgadget_Start();

	FunctionFS_Main();

	return ret;
}
